SOCKETPAIR(2)

NAME
socketpair - create a pair of connected sockets

SYNOPSIS
#include <sys/types.h>
#include <sys/socket.h>

int socketpair(int d, int type, int protocol, int sv[2]);

DESCRIPTION
The socketpair() call creates an unnamed pair of connected sockets in the specified domain d, of the specified type, and using the optionally specified protocol. The descriptors used in referencing the new sockets are returned in sv[0] and sv[1]. The two sockets are indistinguishable.

RETURN VALUE
On success, zero is returned. On error, -1 is returned, and errno is set appropriately.

ERRORS

EAFNOSUPPORT
    The specified address family is not supported on this machine.

EFAULT
    The address sv does not specify a valid part of the process address space.

EMFILE
    Too many descriptors are in use by this process.

ENFILE
    The system limit on the total number of open files has been reached.

EOPNOTSUPP
    The specified protocol does not support creation of socket pairs.

EPROTONOSUPPORT
    The specified protocol is not supported on this machine.

CONFORMING TO
4.4BSD, SUSv2, POSIX 1003.1-2001. The socketpair() function call appeared in 4.2BSD. It is generally portable to/from non-BSD systems supporting clones of the BSD socket layer (including System V variants).

NOTES
On Linux, the only supported domain for this call is AF_UNIX (or synonymously, AF_LOCAL). (Most implementations have the same restriction.)

SEE ALSO
pipe(2), read(2), socket(2), write(2), unix(7)